package com.hikcreate.utils;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.ConnectionFactory;
import org.apache.hadoop.hbase.client.Table;
import org.springframework.stereotype.Component;

import java.io.IOException;
@Component
public class HbaseUtils {


    public Connection getHbseCon(String hbaseAddress, String hbaseZkQuorum) throws IOException {
        Configuration hbaseConf = HBaseConfiguration.create();
        hbaseConf.set("hbase.zookeeper.property.clientPort", hbaseAddress);
        hbaseConf.set("hbase.zookeeper.quorum", hbaseZkQuorum);
        return ConnectionFactory.createConnection(hbaseConf);
    }

    public Table getHbaseTable(Connection hbaseConn, String vehflowHbaseStr) throws IOException {
        return hbaseConn.getTable(TableName.valueOf(vehflowHbaseStr));
    }

    public  void closeHbaseTable(Table vehFlowTable) {
        if (vehFlowTable != null) {
            try {
                vehFlowTable.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }


    public  void clodeHbaseCon(Connection hbaseConn) {
        if (hbaseConn != null) {
            try {
                hbaseConn.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
